"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UseCollectors = UseCollectors;
const use_collectors_constant_1 = require("./use-collectors.constant");
/**
 * Use collectors decorator
 */
function UseCollectors(...collectors) {
    return (target, propertyKey, descriptor) => {
        if (descriptor) {
            Reflect.defineMetadata(use_collectors_constant_1.USE_COLLECTORS_METADATA, collectors, target, propertyKey);
            return descriptor;
        }
        Reflect.defineMetadata(use_collectors_constant_1.USE_COLLECTORS_METADATA, collectors, target.prototype);
        return target;
    };
}
//# sourceMappingURL=use-collectors.decorator.js.map