"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.On = On;
const is_base_event_1 = require("../../../utils/guard/is-base-event");
const on_constant_1 = require("./on.constant");
/**
 * On event decorator
 *
 * Subscribe to Discord event
 */
function On(event) {
    return (target, propertyKey, descriptor) => {
        if ((0, is_base_event_1.IsBaseEvent)(event)) {
            Reflect.defineMetadata(on_constant_1.ON_DECORATOR, { event }, target, propertyKey);
        }
        else {
            Reflect.defineMetadata(on_constant_1.ON_COLLECT_DECORATOR, { event }, target, propertyKey);
        }
        return descriptor;
    };
}
//# sourceMappingURL=on.decorator.js.map