"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Once = Once;
const is_base_event_1 = require("../../../utils/guard/is-base-event");
const once_constant_1 = require("./once.constant");
/**
 * Once handle event decorator
 *
 * Subscribe only once to Discord event
 */
function Once(event) {
    return (target, propertyKey, descriptor) => {
        if ((0, is_base_event_1.IsBaseEvent)(event)) {
            Reflect.defineMetadata(once_constant_1.ONCE_DECORATOR, { event }, target, propertyKey);
        }
        else {
            Reflect.defineMetadata(once_constant_1.ONCE_COLLECT_DECORATOR, { event }, target, propertyKey);
        }
        return descriptor;
    };
}
//# sourceMappingURL=once.decorator.js.map