import { PipeTransform, Type } from '@nestjs/common';
/**
 * Extract `Interaction` instance from event params
 */
export declare function InteractionEvent(property?: string | (Type<PipeTransform> | PipeTransform), ...pipes: (Type<PipeTransform> | PipeTransform)[]): ParameterDecorator;
export declare const EventParams: (...dataOrPipes: (string | PipeTransform<any, any> | Type<PipeTransform<any, any>>)[]) => ParameterDecorator;
export declare function AppliedCollectors(index?: number | (Type<PipeTransform> | PipeTransform), ...pipes: (Type<PipeTransform> | PipeTransform)[]): ParameterDecorator;
/**
 * Extract `Message` instance from event params
 */
export declare function MessageEvent(property?: string | (Type<PipeTransform> | PipeTransform), ...pipes: (Type<PipeTransform> | PipeTransform)[]): ParameterDecorator;
/**
 * Alias for `MessageEvent` decorator
 */
export declare const MSG: typeof MessageEvent;
/**
 * Alias for `InteractionEvent` decorator
 */
export declare const IA: typeof InteractionEvent;
