"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DiscordHostModule = void 0;
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const discovery_service_1 = require("@nestjs/core/discovery/discovery-service");
const collector_explorer_alias_1 = require("./definitions/constants/collector-explorer-alias");
const discord_client_provider_alias_1 = require("./definitions/constants/discord-client-provider-alias");
const discord_collector_provider_alias_1 = require("./definitions/constants/discord-collector-provider-alias");
const discord_command_provider_alias_1 = require("./definitions/constants/discord-command-provider-alias");
const discord_module_contant_1 = require("./definitions/constants/discord-module.contant");
const reflect_metadata_provider_alias_1 = require("./definitions/constants/reflect-metadata-provider-alias");
const collector_register_1 = require("./explorers/collector/collector-register");
const collector_explorer_1 = require("./explorers/collector/collector.explorer");
const interaction_collector_strategy_1 = require("./explorers/collector/strategy/interaction-collector.strategy");
const message_collector_strategy_1 = require("./explorers/collector/strategy/message-collector.strategy");
const react_collector_strategy_1 = require("./explorers/collector/strategy/react-collector.strategy");
const collector_provider_1 = require("./providers/collector.provider");
const discord_client_provider_1 = require("./providers/discord-client.provider");
const discord_command_provider_1 = require("./providers/discord-command.provider");
const reflect_metadata_provider_1 = require("./providers/reflect-metadata.provider");
const client_service_1 = require("./services/client.service");
const instantiation_service_1 = require("./services/instantiation.service");
const option_service_1 = require("./services/option.service");
let DiscordHostModule = class DiscordHostModule {
};
exports.DiscordHostModule = DiscordHostModule;
exports.DiscordHostModule = DiscordHostModule = __decorate([
    (0, common_1.Module)({
        providers: [
            client_service_1.ClientService,
            option_service_1.OptionService,
            react_collector_strategy_1.ReactCollectorStrategy,
            interaction_collector_strategy_1.InteractionCollectorStrategy,
            message_collector_strategy_1.MessageCollectorStrategy,
            collector_register_1.CollectorRegister,
            instantiation_service_1.InstantiationService,
            discovery_service_1.DiscoveryService,
            reflect_metadata_provider_1.ReflectMetadataProvider,
            core_1.MetadataScanner,
            {
                provide: collector_explorer_alias_1.COLLECTOR_EXPLORER_ALIAS,
                useClass: collector_explorer_1.CollectorExplorer,
            },
            {
                provide: reflect_metadata_provider_alias_1.REFLECT_METADATA_PROVIDER_ALIAS,
                useClass: reflect_metadata_provider_1.ReflectMetadataProvider,
            },
            {
                provide: discord_command_provider_alias_1.DISCORD_COMMAND_PROVIDER_ALIAS,
                useClass: discord_command_provider_1.DiscordCommandProvider,
            },
            {
                provide: discord_client_provider_alias_1.DISCORD_CLIENT_PROVIDER_ALIAS,
                useClass: discord_client_provider_1.DiscordClientProvider,
            },
            {
                provide: discord_module_contant_1.DISCORD_MODULE_OPTIONS,
                useFactory: () => ({}),
            },
            {
                provide: discord_collector_provider_alias_1.DISCORD_COLLECTOR_PROVIDER_ALIAS,
                useClass: collector_provider_1.CollectorProvider,
            },
        ],
        exports: [
            client_service_1.ClientService,
            option_service_1.OptionService,
            collector_explorer_alias_1.COLLECTOR_EXPLORER_ALIAS,
            reflect_metadata_provider_alias_1.REFLECT_METADATA_PROVIDER_ALIAS,
            discord_command_provider_alias_1.DISCORD_COMMAND_PROVIDER_ALIAS,
            discord_client_provider_alias_1.DISCORD_CLIENT_PROVIDER_ALIAS,
            discord_collector_provider_alias_1.DISCORD_COLLECTOR_PROVIDER_ALIAS,
            discord_module_contant_1.DISCORD_MODULE_OPTIONS,
        ],
    })
], DiscordHostModule);
//# sourceMappingURL=discord-host.module.js.map