"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var DiscordModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.DiscordModule = void 0;
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const rxjs_1 = require("rxjs");
const inject_discord_client_constant_1 = require("./decorators/client/inject-discord-client.constant");
const collector_explorer_alias_1 = require("./definitions/constants/collector-explorer-alias");
const discord_client_provider_alias_1 = require("./definitions/constants/discord-client-provider-alias");
const discord_collector_provider_alias_1 = require("./definitions/constants/discord-collector-provider-alias");
const discord_command_provider_alias_1 = require("./definitions/constants/discord-command-provider-alias");
const discord_module_contant_1 = require("./definitions/constants/discord-module.contant");
const reflect_metadata_provider_alias_1 = require("./definitions/constants/reflect-metadata-provider-alias");
const discord_host_module_1 = require("./discord-host.module");
const collector_register_1 = require("./explorers/collector/collector-register");
const collector_explorer_1 = require("./explorers/collector/collector.explorer");
const interaction_collector_strategy_1 = require("./explorers/collector/strategy/interaction-collector.strategy");
const message_collector_strategy_1 = require("./explorers/collector/strategy/message-collector.strategy");
const react_collector_strategy_1 = require("./explorers/collector/strategy/react-collector.strategy");
const command_explorer_1 = require("./explorers/command/command.explorer");
const event_explorer_1 = require("./explorers/event/event.explorer");
const option_explorer_1 = require("./explorers/option/option.explorer");
const collector_provider_1 = require("./providers/collector.provider");
const cause_event_constant_1 = require("./providers/constants/cause-event.constant");
const collector_constant_1 = require("./providers/constants/collector.constant");
const discord_client_provider_1 = require("./providers/discord-client.provider");
const discord_command_provider_1 = require("./providers/discord-command.provider");
const reflect_metadata_provider_1 = require("./providers/reflect-metadata.provider");
const build_application_command_service_1 = require("./services/build-application-command.service");
const client_service_1 = require("./services/client.service");
const command_handler_finder_service_1 = require("./services/command-handler-finder.service");
const dto_service_1 = require("./services/dto.service");
const explorer_service_1 = require("./services/explorer.service");
const instantiation_service_1 = require("./services/instantiation.service");
const register_command_service_1 = require("./services/register-command.service");
let DiscordModule = class DiscordModule {
    static { DiscordModule_1 = this; }
    static initSubject = new rxjs_1.Subject();
    static forRootAsync(options) {
        return {
            module: DiscordModule_1,
            imports: options.imports || [],
            providers: [
                ...DiscordModule_1.createAsyncDiscordOptionProviders(options),
                ...DiscordModule_1.createExportedForRootProviders(options),
                instantiation_service_1.InstantiationService,
                register_command_service_1.RegisterCommandService,
                option_explorer_1.OptionExplorer,
                command_explorer_1.CommandExplorer,
                dto_service_1.DtoService,
                event_explorer_1.EventExplorer,
                explorer_service_1.ExplorerService,
                command_handler_finder_service_1.CommandHandlerFinderService,
                build_application_command_service_1.BuildApplicationCommandService,
                react_collector_strategy_1.ReactCollectorStrategy,
                message_collector_strategy_1.MessageCollectorStrategy,
                interaction_collector_strategy_1.InteractionCollectorStrategy,
                collector_register_1.CollectorRegister,
                ...DiscordModule_1.createRequestProvides(),
            ],
            exports: [
                collector_provider_1.CollectorProvider,
                discord_client_provider_1.DiscordClientProvider,
                reflect_metadata_provider_1.ReflectMetadataProvider,
                discord_command_provider_1.DiscordCommandProvider,
                inject_discord_client_constant_1.INJECT_DISCORD_CLIENT,
                collector_constant_1.COLLECTOR,
                cause_event_constant_1.CAUSE_EVENT,
            ],
        };
    }
    static forFeature() {
        return {
            module: DiscordModule_1,
            providers: [
                {
                    provide: inject_discord_client_constant_1.INJECT_DISCORD_CLIENT,
                    useFactory: () => (0, rxjs_1.firstValueFrom)(DiscordModule_1.initSubject), // Should only be called after DiscordClientService init
                },
                {
                    provide: discord_client_provider_1.DiscordClientProvider,
                    useExisting: discord_client_provider_alias_1.DISCORD_CLIENT_PROVIDER_ALIAS,
                },
                {
                    provide: reflect_metadata_provider_1.ReflectMetadataProvider,
                    useExisting: reflect_metadata_provider_alias_1.REFLECT_METADATA_PROVIDER_ALIAS,
                },
                {
                    provide: collector_explorer_1.CollectorExplorer,
                    useExisting: collector_explorer_alias_1.COLLECTOR_EXPLORER_ALIAS,
                },
                {
                    provide: discord_command_provider_1.DiscordCommandProvider,
                    useExisting: discord_command_provider_alias_1.DISCORD_COMMAND_PROVIDER_ALIAS,
                },
                {
                    provide: collector_provider_1.CollectorProvider,
                    useExisting: discord_collector_provider_alias_1.DISCORD_COLLECTOR_PROVIDER_ALIAS,
                },
                ...DiscordModule_1.createRequestProvides(),
            ],
            exports: [
                collector_provider_1.CollectorProvider,
                discord_client_provider_1.DiscordClientProvider,
                reflect_metadata_provider_1.ReflectMetadataProvider,
                discord_command_provider_1.DiscordCommandProvider,
                inject_discord_client_constant_1.INJECT_DISCORD_CLIENT,
                collector_constant_1.COLLECTOR,
                cause_event_constant_1.CAUSE_EVENT,
            ],
        };
    }
    static createExportedForRootProviders(options) {
        return [
            {
                provide: discord_client_provider_1.DiscordClientProvider,
                useFactory: async (discordClientService, discordClientProvider, discordModuleOptions) => {
                    discordClientService.initClient(discordModuleOptions);
                    await discordClientService.setupClient(options.setupClientFactory);
                    DiscordModule_1.initSubject.next(discordClientService.getClient());
                    return discordClientProvider;
                },
                inject: [
                    client_service_1.ClientService,
                    discord_client_provider_alias_1.DISCORD_CLIENT_PROVIDER_ALIAS,
                    discord_module_contant_1.DISCORD_MODULE_OPTIONS,
                ],
            },
            {
                provide: discord_command_provider_1.DiscordCommandProvider,
                useExisting: discord_command_provider_alias_1.DISCORD_COMMAND_PROVIDER_ALIAS,
            },
            {
                provide: collector_explorer_1.CollectorExplorer,
                useExisting: collector_explorer_alias_1.COLLECTOR_EXPLORER_ALIAS,
            },
            {
                provide: collector_provider_1.CollectorProvider,
                useExisting: discord_collector_provider_alias_1.DISCORD_COLLECTOR_PROVIDER_ALIAS,
            },
            {
                provide: inject_discord_client_constant_1.INJECT_DISCORD_CLIENT,
                useFactory: (discordClientProvider) => discordClientProvider.getClient(),
                inject: [discord_client_provider_1.DiscordClientProvider],
            },
            reflect_metadata_provider_1.ReflectMetadataProvider,
        ];
    }
    static createAsyncDiscordOptionProviders(options) {
        if (options) {
            if (options.useFactory) {
                return [
                    {
                        provide: discord_module_contant_1.DISCORD_MODULE_OPTIONS,
                        useFactory: options.useFactory,
                        inject: options.inject || [],
                    },
                ];
            }
            else {
                // For useClass and useExisting...
                const useClass = options.useClass;
                const providers = [
                    {
                        provide: discord_module_contant_1.DISCORD_MODULE_OPTIONS,
                        useFactory: async (optionsFactory) => optionsFactory.createDiscordOptions(),
                        inject: [options.useExisting || options.useClass],
                    },
                ];
                if (useClass) {
                    providers.push({
                        provide: useClass,
                        useClass,
                    });
                }
                return providers;
            }
        }
        else {
            return [
                {
                    provide: discord_module_contant_1.DISCORD_MODULE_OPTIONS,
                    useValue: {},
                },
            ];
        }
    }
    static createRequestProvides() {
        return [
            {
                provide: collector_constant_1.COLLECTOR,
                useFactory: ({ collector }) => collector,
                inject: [core_1.REQUEST],
                scope: common_1.Scope.REQUEST,
            },
            {
                provide: cause_event_constant_1.CAUSE_EVENT,
                useFactory: ({ causeEvent }) => causeEvent,
                inject: [core_1.REQUEST],
                scope: common_1.Scope.REQUEST,
            },
        ];
    }
};
exports.DiscordModule = DiscordModule;
exports.DiscordModule = DiscordModule = DiscordModule_1 = __decorate([
    (0, common_1.Module)({
        imports: [discord_host_module_1.DiscordHostModule, core_1.DiscoveryModule],
    })
], DiscordModule);
//# sourceMappingURL=discord.module.js.map