"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CollectorRegister = void 0;
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const external_context_creator_1 = require("@nestjs/core/helpers/external-context-creator");
const event_param_constant_1 = require("../../decorators/param/event-param.constant");
const discord_param_factory_1 = require("../../factory/discord-param-factory");
const option_service_1 = require("../../services/option.service");
let CollectorRegister = class CollectorRegister {
    externalContextCreator;
    optionService;
    constructor(externalContextCreator, optionService) {
        this.externalContextCreator = externalContextCreator;
        this.optionService = optionService;
    }
    discordParamFactory = new discord_param_factory_1.DiscordParamFactory();
    subscribeToEvents(collector, events, classInstance) {
        Object.entries(events).forEach(([methodName, { eventMethod, eventName }]) => {
            const handler = this.externalContextCreator.create(classInstance, classInstance[methodName], methodName, event_param_constant_1.EVENT_PARAMS_DECORATOR, this.discordParamFactory);
            collector[eventMethod](eventName, async (...eventArgs) => {
                try {
                    await handler(...eventArgs);
                }
                catch (exception) {
                    if (exception instanceof common_1.ForbiddenException &&
                        this.optionService.getClientData().isTrowForbiddenException)
                        throw exception;
                }
            });
        });
    }
    async registerRequest(moduleRef, classInstance, requestObject) {
        if (moduleRef.introspect(classInstance.constructor).scope === common_1.Scope.DEFAULT)
            return classInstance;
        const contextId = core_1.ContextIdFactory.create();
        moduleRef.registerRequestByContextId(requestObject, contextId);
        return moduleRef.resolve(classInstance.constructor, contextId);
    }
};
exports.CollectorRegister = CollectorRegister;
exports.CollectorRegister = CollectorRegister = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [external_context_creator_1.ExternalContextCreator,
        option_service_1.OptionService])
], CollectorRegister);
//# sourceMappingURL=collector-register.js.map