import { MetadataScanner } from '@nestjs/core';
import { InteractionCollector, MappedInteractionTypes, MessageCollector, MessageComponentType, ReactionCollector } from 'discord.js';
import { ReflectMetadataProvider } from '../../providers/reflect-metadata.provider';
import { InstantiationService } from '../../services/instantiation.service';
import { MethodExplorer } from '../interfaces/method-explorer';
import { MethodExplorerOptions } from '../interfaces/method-explorer-options';
import { InteractionCollectorStrategy } from './strategy/interaction-collector.strategy';
import { MessageCollectorStrategy } from './strategy/message-collector.strategy';
import { ReactCollectorStrategy } from './strategy/react-collector.strategy';
import { UseCollectorApplyOptions } from './use-collector-apply-options';
export declare class CollectorExplorer implements MethodExplorer {
    private readonly metadataProvider;
    private readonly instantiationService;
    private readonly metadataScanner;
    private readonly reactCollectorStrategy;
    private readonly interactionCollectorStrategy;
    private readonly messageCollectorStrategy;
    private readonly cachedCollectors;
    constructor(metadataProvider: ReflectMetadataProvider, instantiationService: InstantiationService, metadataScanner: MetadataScanner, reactCollectorStrategy: ReactCollectorStrategy, interactionCollectorStrategy: InteractionCollectorStrategy, messageCollectorStrategy: MessageCollectorStrategy);
    explore({ instance, methodName, }: MethodExplorerOptions): Promise<void>;
    applyCollector(options: UseCollectorApplyOptions): Promise<(ReactionCollector | MessageCollector | InteractionCollector<MappedInteractionTypes[MessageComponentType]>)[]>;
    private getCollectorsInfo;
    private exploreBaseInfo;
    private getInstanceMethods;
    private findFilterMethod;
}
