import { ModuleRef } from '@nestjs/core';
import { InteractionCollector, MappedInteractionTypes, MessageComponentType } from 'discord.js';
import { CollectorMetadata } from '../collector-metadata';
import { CollectorRegister } from '../collector-register';
import { UseCollectorApplyOptions } from '../use-collector-apply-options';
import { CollectorStrategy } from './collector-strategy';
export declare class InteractionCollectorStrategy implements CollectorStrategy {
    private readonly collectorRegister;
    constructor(collectorRegister: CollectorRegister);
    setupCollector({ event, eventArgs }: UseCollectorApplyOptions, { metadata, filterMethodName, events, classInstance }: CollectorMetadata, moduleRef: ModuleRef): Promise<InteractionCollector<MappedInteractionTypes[MessageComponentType]>>;
    private isMessageEvent;
    private isInteractionEvent;
}
