"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InteractionCollectorStrategy = void 0;
const common_1 = require("@nestjs/common");
const discord_js_1 = require("discord.js");
const collector_register_1 = require("../collector-register");
let InteractionCollectorStrategy = class InteractionCollectorStrategy {
    collectorRegister;
    constructor(collectorRegister) {
        this.collectorRegister = collectorRegister;
    }
    async setupCollector({ event, eventArgs }, { metadata, filterMethodName, events, classInstance }, moduleRef) {
        if (!this.isMessageEvent(event, eventArgs) &&
            !this.isInteractionEvent(event, eventArgs))
            return;
        const [messageOrInteraction] = eventArgs;
        if (messageOrInteraction.channel.type !== discord_js_1.ChannelType.GuildText) {
            return;
        }
        const interactionCollectorOptions = {
            ...metadata,
        };
        const interactionCollector = messageOrInteraction.channel.createMessageComponentCollector(interactionCollectorOptions);
        const executedClassInstance = await this.collectorRegister.registerRequest(moduleRef, classInstance, {
            collector: interactionCollector,
            causeEvent: messageOrInteraction,
        });
        if (filterMethodName)
            interactionCollector.filter = (...filterArgs) => executedClassInstance[filterMethodName](...filterArgs);
        this.collectorRegister.subscribeToEvents(interactionCollector, events, executedClassInstance);
        return interactionCollector;
    }
    isMessageEvent(event, context) {
        return event === 'messageCreate';
    }
    isInteractionEvent(event, context) {
        return event === 'interactionCreate';
    }
};
exports.InteractionCollectorStrategy = InteractionCollectorStrategy;
exports.InteractionCollectorStrategy = InteractionCollectorStrategy = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [collector_register_1.CollectorRegister])
], InteractionCollectorStrategy);
//# sourceMappingURL=interaction-collector.strategy.js.map