import { ExternalContextCreator } from '@nestjs/core/helpers/external-context-creator';
import { ReflectMetadataProvider } from '../../providers/reflect-metadata.provider';
import { BuildApplicationCommandService } from '../../services/build-application-command.service';
import { ClientService } from '../../services/client.service';
import { OptionService } from '../../services/option.service';
import { ClassExplorer } from '../interfaces/class-explorer';
import { ClassExplorerOptions } from '../interfaces/class-explorer-options';
export declare class CommandExplorer implements ClassExplorer {
    private readonly discordClientService;
    private readonly metadataProvider;
    private readonly buildApplicationCommandService;
    private readonly externalContextCreator;
    private readonly optionService;
    constructor(discordClientService: ClientService, metadataProvider: ReflectMetadataProvider, buildApplicationCommandService: BuildApplicationCommandService, externalContextCreator: ExternalContextCreator, optionService: OptionService);
    private readonly discordParamFactory;
    private readonly event;
    explore({ instance }: ClassExplorerOptions): Promise<void>;
}
