"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DiscordParamFactory = void 0;
const discord_param_type_1 = require("./discord-param-type");
class DiscordParamFactory {
    exchangeKeyForValue(type, data, args) {
        switch (type) {
            case discord_param_type_1.DiscordParamType.MESSAGE: {
                const message = args[0];
                return data && typeof data === 'string' && message
                    ? message[data]
                    : message;
            }
            case discord_param_type_1.DiscordParamType.INTERACTION: {
                const interaction = args[0];
                return data && typeof data === 'string' && interaction
                    ? interaction[data]
                    : interaction;
            }
            case discord_param_type_1.DiscordParamType.EVENT_PARAMS:
                return args;
            case discord_param_type_1.DiscordParamType.APPLIED_COLLECTORS: {
                const { collectors } = args[args.length - 1];
                const index = data && Number(data);
                return !isNaN(index) && collectors && collectors.length
                    ? collectors[index]
                    : collectors;
            }
            default:
                return null;
        }
    }
}
exports.DiscordParamFactory = DiscordParamFactory;
//# sourceMappingURL=discord-param-factory.js.map