import { Type } from '@nestjs/common';
import { ChannelType, MessageChannelCollectorOptionsParams, MessageCollectorOptions, MessageComponentType } from 'discord.js';
import { DiscordReactionCollectorOptions } from '../decorators/collector/reaction-collector/reaction-collector-options';
import { ChatInputCommandOptions } from '../decorators/command/chat-input-command-options';
import { OnCollectDecoratorOptions } from '../decorators/event/on-collect-decorator-options';
import { OnDecoratorOptions } from '../decorators/event/on-decorator-options';
import { FieldOptions } from '../decorators/modal/field/field-options';
import { ChoiceOptions } from '../decorators/option/choice/choice-options';
import { NonParamOptions } from '../decorators/option/param/non-param-options';
import { NumericParamOptions } from '../decorators/option/param/numeric-param-options';
import { StringParamOptions } from '../decorators/option/param/string-param-options';
import { SubCommandOptions } from '../decorators/sub-command/sub-command-options';
import { ArgNumOptions } from '../decorators/transformation/arg-num/arg-num-options';
import { ArgRangeOptions } from '../decorators/transformation/arg-range/arg-range-options';
export declare class ReflectMetadataProvider {
    getCommandDecoratorMetadata(instance: InstanceType<any>): ChatInputCommandOptions;
    getHandlerDecoratorMetadata(instance: InstanceType<any>, methodName: string): Record<string, any>;
    getSubCommandDecoratorMetadata(instance: InstanceType<any>): SubCommandOptions;
    getOnEventDecoratorMetadata(instance: InstanceType<any>, methodName: string): OnDecoratorOptions;
    getOnceEventDecoratorMetadata(instance: InstanceType<any>, methodName: string): OnDecoratorOptions;
    getArgNumDecoratorMetadata(type: Type, propertyKey: string): (last?: number) => ArgNumOptions;
    getArgRangeDecoratorMetadata(instance: InstanceType<any>, propertyKey: string): (last?: number) => ArgRangeOptions;
    getOnCollectEventDecoratorMetadata(instance: InstanceType<any>, methodName: string): OnCollectDecoratorOptions;
    getOnceCollectEventDecoratorMetadata(instance: InstanceType<any>, methodName: string): OnCollectDecoratorOptions;
    getFilterDecoratorMetadata(instance: InstanceType<any>, methodName: string): Record<string, any>;
    getParamTypesMetadata(instance: InstanceType<any>, methodName: string): Type[];
    getPropertyTypeMetadata(instance: InstanceType<any>, methodName: string): Type;
    getParamDecoratorMetadata(type: Type, propertyKey: string): NumericParamOptions & StringParamOptions & NonParamOptions;
    getChoiceDecoratorMetadata(type: Type, propertyKey: string): ChoiceOptions;
    getChannelDecoratorMetadata(type: Type, propertyKey: string): ChannelType[];
    getReactionCollectorDecoratorMetadata(instance: InstanceType<any>): DiscordReactionCollectorOptions;
    getMessageCollectorDecoratorMetadata(instance: InstanceType<any>): MessageCollectorOptions;
    getInteractionCollectorDecoratorMetadata<T extends MessageComponentType>(instance: InstanceType<any>): MessageChannelCollectorOptionsParams<T, true>;
    getUseCollectorsDecoratorMetadata(instance: InstanceType<any>, methodName?: string): Type[];
    getFiledDecoratorMetadata(type: Type, propertyKey: string): FieldOptions;
    getTextInputValueDecoratorMetadata(type: Type, propertyKey: string): {
        customId?: string;
    };
    isDto(type: Type): boolean;
}
