"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReflectMetadataProvider = void 0;
const common_1 = require("@nestjs/common");
const filter_constant_1 = require("../decorators/collector/filter/filter.constant");
const interaction_collector_constant_1 = require("../decorators/collector/interaction-collector/interaction-collector.constant");
const message_collector_constant_1 = require("../decorators/collector/message-collector/message-collector.constant");
const reaction_collector_constant_1 = require("../decorators/collector/reaction-collector/reaction-collector.constant");
const use_collectors_constant_1 = require("../decorators/collector/use-collectors/use-collectors.constant");
const command_constant_1 = require("../decorators/command/command.constant");
const handler_constant_1 = require("../decorators/command/handler/handler.constant");
const on_constant_1 = require("../decorators/event/on/on.constant");
const once_constant_1 = require("../decorators/event/once/once.constant");
const field_constant_1 = require("../decorators/modal/field/field.constant");
const text_input_value_constant_1 = require("../decorators/modal/text-input-value/text-input-value.constant");
const channel_constant_1 = require("../decorators/option/channel/channel.constant");
const choice_constant_1 = require("../decorators/option/choice/choice.constant");
const param_constant_1 = require("../decorators/option/param/param.constant");
const sub_command_constant_1 = require("../decorators/sub-command/sub-command.constant");
const arg_num_constant_1 = require("../decorators/transformation/arg-num/arg-num.constant");
const arg_range_constant_1 = require("../decorators/transformation/arg-range/arg-range.constant");
let ReflectMetadataProvider = class ReflectMetadataProvider {
    getCommandDecoratorMetadata(instance) {
        return Reflect.getMetadata(command_constant_1.COMMAND_DECORATOR, instance);
    }
    getHandlerDecoratorMetadata(instance, methodName) {
        return Reflect.getMetadata(handler_constant_1.HANDLER_DECORATOR, instance, methodName);
    }
    getSubCommandDecoratorMetadata(instance) {
        return Reflect.getMetadata(sub_command_constant_1.SUB_COMMAND_DECORATOR, instance);
    }
    getOnEventDecoratorMetadata(instance, methodName) {
        return Reflect.getMetadata(on_constant_1.ON_DECORATOR, instance, methodName);
    }
    getOnceEventDecoratorMetadata(instance, methodName) {
        return Reflect.getMetadata(once_constant_1.ONCE_DECORATOR, instance, methodName);
    }
    getArgNumDecoratorMetadata(type, propertyKey) {
        return Reflect.getMetadata(arg_num_constant_1.ARG_NUM_DECORATOR, type, propertyKey);
    }
    getArgRangeDecoratorMetadata(instance, propertyKey) {
        return Reflect.getMetadata(arg_range_constant_1.ARG_RANGE_DECORATOR, instance, propertyKey);
    }
    getOnCollectEventDecoratorMetadata(instance, methodName) {
        return Reflect.getMetadata(on_constant_1.ON_COLLECT_DECORATOR, instance, methodName);
    }
    getOnceCollectEventDecoratorMetadata(instance, methodName) {
        return Reflect.getMetadata(once_constant_1.ONCE_COLLECT_DECORATOR, instance, methodName);
    }
    getFilterDecoratorMetadata(instance, methodName) {
        return Reflect.getMetadata(filter_constant_1.FILTER_METADATA, instance, methodName);
    }
    getParamTypesMetadata(instance, methodName) {
        return Reflect.getMetadata('design:paramtypes', instance, methodName);
    }
    getPropertyTypeMetadata(instance, methodName) {
        return Reflect.getMetadata('design:type', instance, methodName);
    }
    getParamDecoratorMetadata(type, propertyKey) {
        return Reflect.getMetadata(param_constant_1.PARAM_DECORATOR, type, propertyKey);
    }
    getChoiceDecoratorMetadata(type, propertyKey) {
        return Reflect.getMetadata(choice_constant_1.CHOICE_DECORATOR, type, propertyKey);
    }
    getChannelDecoratorMetadata(type, propertyKey) {
        return Reflect.getMetadata(channel_constant_1.CHANNEL_DECORATOR, type, propertyKey);
    }
    getReactionCollectorDecoratorMetadata(instance) {
        return Reflect.getMetadata(reaction_collector_constant_1.REACTION_COLLECTOR_METADATA, instance);
    }
    getMessageCollectorDecoratorMetadata(instance) {
        return Reflect.getMetadata(message_collector_constant_1.MESSAGE_COLLECTOR_METADATA, instance);
    }
    getInteractionCollectorDecoratorMetadata(instance) {
        return Reflect.getMetadata(interaction_collector_constant_1.INTERACTION_COLLECTOR_METADATA, instance);
    }
    getUseCollectorsDecoratorMetadata(instance, methodName) {
        return Reflect.getMetadata(use_collectors_constant_1.USE_COLLECTORS_METADATA, instance, methodName);
    }
    getFiledDecoratorMetadata(type, propertyKey) {
        return Reflect.getMetadata(field_constant_1.FIELD_DECORATOR, type, propertyKey);
    }
    getTextInputValueDecoratorMetadata(type, propertyKey) {
        return Reflect.getMetadata(text_input_value_constant_1.TEXT_INPUT_VALUE_DECORATOR, type, propertyKey);
    }
    isDto(type) {
        try {
            const instance = new type();
            const allProperties = Object.keys(instance);
            return allProperties.some((property) => !!(this.getParamDecoratorMetadata(type, property) ||
                this.getArgNumDecoratorMetadata(type, property) ||
                this.getArgNumDecoratorMetadata(type, property) ||
                this.getFiledDecoratorMetadata(type, property) ||
                this.getTextInputValueDecoratorMetadata(type, property)));
        }
        catch {
            return false;
        }
    }
};
exports.ReflectMetadataProvider = ReflectMetadataProvider;
exports.ReflectMetadataProvider = ReflectMetadataProvider = __decorate([
    (0, common_1.Injectable)()
], ReflectMetadataProvider);
//# sourceMappingURL=reflect-metadata.provider.js.map