import { ModuleRef } from '@nestjs/core';
import { ChatInputCommandOptions } from '../decorators/command/chat-input-command-options';
import { CommandListenerDescribe } from '../explorers/command/interfaces/command-listener-describe';
import { DiscordCommandProvider } from '../providers/discord-command.provider';
import { ReflectMetadataProvider } from '../providers/reflect-metadata.provider';
import { CommandHandlerFinderService } from './command-handler-finder.service';
import { DtoService } from './dto.service';
export declare class BuildApplicationCommandService {
    private readonly moduleRef;
    private readonly metadataProvider;
    private readonly discordCommandProvider;
    private readonly dtoService;
    private readonly commandHandlerFinderService;
    constructor(moduleRef: ModuleRef, metadataProvider: ReflectMetadataProvider, discordCommandProvider: DiscordCommandProvider, dtoService: DtoService, commandHandlerFinderService: CommandHandlerFinderService);
    exploreCommand(instance: InstanceType<any>, chatInputCommandOptions: ChatInputCommandOptions): Promise<CommandListenerDescribe[]>;
    private exploreSubCommandOptions;
    private getSubCommandGroupOptions;
    private getSubCommandOptions;
    private getBaseApplicationCommandData;
    private getMethodName;
}
