import { OnApplicationBootstrap, OnApplicationShutdown } from '@nestjs/common';
import { Client, WebhookClient } from 'discord.js';
import { SetupClientFactory } from '../definitions/interfaces/discord-module-async-options';
import { DiscordModuleOption } from '../definitions/interfaces/discord-module-options';
import { OptionService } from './option.service';
export declare class ClientService implements OnApplicationBootstrap, OnApplicationShutdown {
    private discordOptionService;
    private readonly logger;
    private webhookClient;
    private client;
    constructor(discordOptionService: OptionService);
    initClient(options: DiscordModuleOption): void;
    getClient(): Client;
    setupClient(setupFunction?: SetupClientFactory): Promise<void>;
    getWebhookClient(): WebhookClient;
    onApplicationBootstrap(): Promise<void>;
    onApplicationShutdown(): void;
    private createWebhookClient;
}
