"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var ClientService_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.ClientService = void 0;
const common_1 = require("@nestjs/common");
const discord_js_1 = require("discord.js");
const option_service_1 = require("./option.service");
let ClientService = ClientService_1 = class ClientService {
    discordOptionService;
    logger = new common_1.Logger(ClientService_1.name);
    webhookClient;
    client;
    constructor(discordOptionService) {
        this.discordOptionService = discordOptionService;
    }
    initClient(options) {
        this.discordOptionService.updateOptions(options);
        const { token, webhook, discordClientOptions } = this.discordOptionService.getClientData();
        this.client = new discord_js_1.Client(discordClientOptions);
        this.client.token = token;
        this.webhookClient = this.createWebhookClient(webhook);
    }
    getClient() {
        return this.client;
    }
    async setupClient(setupFunction) {
        if (!setupFunction)
            return;
        await setupFunction(this.client);
    }
    getWebhookClient() {
        return this.webhookClient;
    }
    async onApplicationBootstrap() {
        const { autoLogin, failOnLogin } = this.discordOptionService.getClientData();
        if (!autoLogin)
            return;
        try {
            await this.client.login();
        }
        catch (error) {
            this.logger.error('Failed to connect to Discord API');
            this.logger.error(error);
            if (failOnLogin)
                throw error;
        }
    }
    onApplicationShutdown() {
        const { shutdownOnAppDestroy } = this.discordOptionService.getClientData();
        if (shutdownOnAppDestroy)
            this.client.destroy();
    }
    createWebhookClient(webhookOptions) {
        if (!webhookOptions)
            return;
        return new discord_js_1.WebhookClient(webhookOptions);
    }
};
exports.ClientService = ClientService;
exports.ClientService = ClientService = ClientService_1 = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [option_service_1.OptionService])
], ClientService);
//# sourceMappingURL=client.service.js.map