"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CommandHandlerFinderService = void 0;
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const rxjs_1 = require("rxjs");
const reflect_metadata_provider_1 = require("../providers/reflect-metadata.provider");
let CommandHandlerFinderService = class CommandHandlerFinderService {
    metadataScanner;
    reflectMetadataProvider;
    constructor(metadataScanner, reflectMetadataProvider) {
        this.metadataScanner = metadataScanner;
        this.reflectMetadataProvider = reflectMetadataProvider;
    }
    async searchHandler(instance) {
        const methodNames = new Set(this.getMethodsFromInstance(instance));
        if (methodNames.size === 0)
            throw new Error(`Command handler not found in class ${instance.constructor.name}`);
        const handlerData = await (0, rxjs_1.firstValueFrom)((0, rxjs_1.from)(methodNames).pipe((0, rxjs_1.map)((methodName) => ({
            metadata: this.reflectMetadataProvider.getHandlerDecoratorMetadata(instance, methodName),
            methodName,
        })), (0, rxjs_1.filter)(({ metadata }) => !!metadata), (0, rxjs_1.throwIfEmpty)(() => new Error(`Command handler not found in class ${instance.constructor.name}`))));
        return handlerData.methodName;
    }
    getMethodsFromInstance(instance) {
        if (typeof this.metadataScanner.getAllMethodNames === 'function') {
            return this.metadataScanner.getAllMethodNames(Object.getPrototypeOf(instance));
        }
        // TODO: Remove later deprecated method
        return this.metadataScanner.getAllFilteredMethodNames(Object.getPrototypeOf(instance));
    }
};
exports.CommandHandlerFinderService = CommandHandlerFinderService;
exports.CommandHandlerFinderService = CommandHandlerFinderService = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [core_1.MetadataScanner,
        reflect_metadata_provider_1.ReflectMetadataProvider])
], CommandHandlerFinderService);
//# sourceMappingURL=command-handler-finder.service.js.map