import { Type } from '@nestjs/common';
import { ModuleRef } from '@nestjs/core';
import { ApplicationCommandAutocompleteNumericOptionData, ApplicationCommandAutocompleteStringOptionData, ApplicationCommandBooleanOptionData, ApplicationCommandChannelOptionData, ApplicationCommandMentionableOptionData, ApplicationCommandNonOptionsData, ApplicationCommandNumericOptionData, ApplicationCommandRoleOptionData, ApplicationCommandStringOptionData, ApplicationCommandUserOptionData } from 'discord.js';
import { OptionExplorer } from '../explorers/option/option.explorer';
import { ReflectMetadataProvider } from '../providers/reflect-metadata.provider';
export type NonCommandData = ApplicationCommandNonOptionsData | ApplicationCommandChannelOptionData | ApplicationCommandAutocompleteNumericOptionData | ApplicationCommandAutocompleteStringOptionData | ApplicationCommandNumericOptionData | ApplicationCommandStringOptionData | ApplicationCommandRoleOptionData | ApplicationCommandUserOptionData | ApplicationCommandMentionableOptionData | ApplicationCommandBooleanOptionData;
export declare class DtoService {
    private readonly metadataProvider;
    private readonly moduleRef;
    private readonly optionExplorer;
    constructor(metadataProvider: ReflectMetadataProvider, moduleRef: ModuleRef, optionExplorer: OptionExplorer);
    getDtoMetatype(commandInstance: InstanceType<any>, methodName: string): Promise<InstanceType<any>>;
    exploreDtoOptions(dtoType: Type): NonCommandData[];
    private sortByRequired;
}
