"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DtoService = void 0;
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const rxjs_1 = require("rxjs");
const option_explorer_1 = require("../explorers/option/option.explorer");
const reflect_metadata_provider_1 = require("../providers/reflect-metadata.provider");
let DtoService = class DtoService {
    metadataProvider;
    moduleRef;
    optionExplorer;
    constructor(metadataProvider, moduleRef, optionExplorer) {
        this.metadataProvider = metadataProvider;
        this.moduleRef = moduleRef;
        this.optionExplorer = optionExplorer;
    }
    async getDtoMetatype(commandInstance, methodName) {
        const paramsTypes = this.metadataProvider.getParamTypesMetadata(commandInstance, methodName);
        if (!paramsTypes)
            return;
        const [commandOption] = await (0, rxjs_1.lastValueFrom)((0, rxjs_1.from)(paramsTypes).pipe((0, rxjs_1.map)((type) => {
            return {
                type,
                isDto: this.metadataProvider.isDto(type),
            };
        }), (0, rxjs_1.filter)(({ isDto }) => isDto), (0, rxjs_1.toArray)()));
        if (!commandOption)
            return;
        return commandOption.type;
    }
    exploreDtoOptions(dtoType) {
        const optionMetadata = this.optionExplorer.explore(dtoType);
        const commandOptions = [];
        for (const property in optionMetadata) {
            const propertyOptions = optionMetadata[property];
            const { name, description, required = false, type, minValue, maxValue, minLength, maxLength, autocomplete, nameLocalizations, descriptionLocalizations, } = propertyOptions.param;
            commandOptions.push({
                name,
                description,
                required,
                type,
                autocomplete,
                minValue,
                maxValue,
                minLength,
                maxLength,
                nameLocalizations,
                descriptionLocalizations,
                choices: propertyOptions.choice,
                channelTypes: propertyOptions.channelTypes,
            });
        }
        return this.sortByRequired(commandOptions);
    }
    sortByRequired(options) {
        return options.sort((first, second) => first.required > second.required ? -1 : 1);
    }
};
exports.DtoService = DtoService;
exports.DtoService = DtoService = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [reflect_metadata_provider_1.ReflectMetadataProvider,
        core_1.ModuleRef,
        option_explorer_1.OptionExplorer])
], DtoService);
//# sourceMappingURL=dto.service.js.map