"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExplorerService = void 0;
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const collector_explorer_1 = require("../explorers/collector/collector.explorer");
const command_explorer_1 = require("../explorers/command/command.explorer");
const event_explorer_1 = require("../explorers/event/event.explorer");
const is_object_1 = require("../utils/function/is-object");
const register_command_service_1 = require("./register-command.service");
let ExplorerService = class ExplorerService {
    discoveryService;
    metadataScanner;
    eventExplorer;
    commandExplorer;
    registerCommandService;
    collectorExplorer;
    constructor(discoveryService, metadataScanner, eventExplorer, commandExplorer, registerCommandService, collectorExplorer) {
        this.discoveryService = discoveryService;
        this.metadataScanner = metadataScanner;
        this.eventExplorer = eventExplorer;
        this.commandExplorer = commandExplorer;
        this.registerCommandService = registerCommandService;
        this.collectorExplorer = collectorExplorer;
    }
    async onModuleInit() {
        const providers = this.discoveryService.getProviders();
        const controllers = this.discoveryService.getControllers();
        await this.exploreDecorators(providers, controllers);
    }
    async exploreDecorators(providers, controllers) {
        const methodExplorers = [this.eventExplorer];
        const classExplorers = [this.commandExplorer];
        await Promise.all(providers
            .concat(controllers)
            .map(async ({ instance }) => {
            if (!instance || !(0, is_object_1.IsObject)(instance))
                return;
            await Promise.all(classExplorers.map((explorer) => explorer.explore({ instance })));
            const methodNames = this.scanMetadata(instance);
            await this.exploreClassOrMethod([this.collectorExplorer], instance, methodNames);
            await Promise.all(methodExplorers.map((explorer) => Promise.all(methodNames.map((methodName) => explorer.explore({
                instance,
                methodName,
            })))));
        }));
        await this.registerCommandService.register();
    }
    exploreClassOrMethod(explorers, instance, methodNames) {
        return Promise.all(explorers.map(async (explorer) => {
            if (methodNames.length)
                for await (const methodName of methodNames)
                    await explorer.explore({ instance, methodName });
            await explorer.explore({ instance });
        }));
    }
    scanMetadata(instance) {
        return this.metadataScanner.scanFromPrototype(instance, Object.getPrototypeOf(instance), (methodName) => methodName);
    }
};
exports.ExplorerService = ExplorerService;
exports.ExplorerService = ExplorerService = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [core_1.DiscoveryService,
        core_1.MetadataScanner,
        event_explorer_1.EventExplorer,
        command_explorer_1.CommandExplorer,
        register_command_service_1.RegisterCommandService,
        collector_explorer_1.CollectorExplorer])
], ExplorerService);
//# sourceMappingURL=explorer.service.js.map