"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const discord_js_1 = require("discord.js");
const discord_command_provider_1 = require("../providers/discord-command.provider");
const option_service_1 = require("./option.service");
const register_command_service_1 = require("./register-command.service");
describe('Register command service', () => {
    let commandProvider;
    let client;
    let optionService;
    beforeEach(() => {
        commandProvider = new discord_command_provider_1.DiscordCommandProvider();
        client = new discord_js_1.Client({ intents: [] });
        optionService = new option_service_1.OptionService();
        class PlayCommand {
        }
        commandProvider.addCommand(PlayCommand, {
            additionalOptions: { forGuild: undefined },
            commandData: {
                defaultMemberPermissions: undefined,
                description: 'Play command',
                descriptionLocalizations: undefined,
                dmPermission: undefined,
                name: 'play',
                nameLocalizations: undefined,
                options: [],
                type: 1,
            },
        });
    });
    it('should register command globally', async () => {
        optionService.updateOptions({
            token: '',
            discordClientOptions: {
                intents: [],
            },
        });
        const setCommandSpy = jest.spyOn(client.application.commands, 'set');
        const registerCommandService = new register_command_service_1.RegisterCommandService(commandProvider, client, optionService);
        await registerCommandService.register();
        // client.emit('ready', client);
    });
});
//# sourceMappingURL=register-command.service.spec.js.map